//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 変換モデルヘッダ
 * @author Junpee
 */

#ifndef TRANSLATION_MODEL_H_
#define TRANSLATION_MODEL_H_

namespace Lamp{
	class Scene;
	class AnimationManager;
	class AnimationSet;
}

#include <Core/Container/ArrayList.h>

namespace LampForMaya{

class TranslationMeshManager;
class TranslationMesh;
class TranslationStandardModel;
class TranslationCharacterModel;

//------------------------------------------------------------------------------
/**
 * 変換モデル
 */
class TranslationModel{
friend class TranslationModelManager;
public:
	/**
	 * デストラクタ
	 */
	virtual ~TranslationModel();

	//--------------------------------------------------------------------------
	/**
	 * 分析
	 * @param meshManager メッシュマネージャ
	 * @return 成功すればtrue
	 */
	virtual bool analyze(TranslationMeshManager* meshManager) = 0;

	/**
	 * ピボットのコンパイル
	 * @param pivot ピボット位置
	 */
	virtual void compilePivot(const Vector3& pivot);

	/**
	 * アニメーションの分析
	 * @return 成功すればtrue
	 */
	virtual bool analyzeAnimation(){ return true; }

	//--------------------------------------------------------------------------
	/**
	 * Lampへの変換
	 * @param scene シーン
	 * @return 成功すればtrue
	 */
	virtual bool convertToLamp(Scene* scene) = 0;

	/**
	 * アニメーションの変換
	 * @param animationManager アニメーションマネージャ
	 * @param animationSet アニメーションセット
	 * @return 成功すればtrue
	 */
	virtual bool convertAnimation(
		AnimationManager* animationManager, AnimationSet* animationSet){
		return true;
	}

	//--------------------------------------------------------------------------
	/**
	 * オブジェクトの取得
	 * @return オブジェクト
	 */
	virtual MObject getObject() const{ return object_; }

	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual String getName() const{ return name_; }

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * 標準モデルかどうか
	 * @return 標準モデルならtrue
	 */
	virtual bool isStandardModel() const{ return false; }

	/**
	 * 標準モデルへのキャスト
	 * @return 標準モデル。型が違えばNULLを返す。
	 */
	virtual TranslationStandardModel* castStandardModel() const{
		if(isStandardModel()){
			return (TranslationStandardModel*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * キャラクタモデルかどうか
	 * @return キャラクタモデルならtrue
	 */
	virtual bool isCharacterModel() const{ return false; }

	/**
	 * キャラクタモデルへのキャスト
	 * @return キャラクタモデル。型が違えばNULLを返す。
	 */
	virtual TranslationCharacterModel* castCharacterModel() const{
		if(isCharacterModel()){
			return (TranslationCharacterModel*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------

protected:
	/**
	 * コンストラクタ
	 * @param initializeObject 初期化するオブジェクト
	 * @param initializeName 初期化する名前
	 */
	TranslationModel(
		const MObject& initializeObject, const String& initializeName);

	/**
	 * モデルの解析
	 */
	virtual bool analyzeModel();

	/**
	 * シェーダ名の取得
	 * @param shadingEngine シェーディングエンジン
	 * @return シェーダ名
	 */
	virtual String getShaderName(const MObject& shadingEngine);

	/// メッシュ配列
	ArrayList<TranslationMesh*> meshes_;
	/// オブジェクト
	MObject object_;
	/// 名前
	String name_;
	/// 表示フラグ
	bool visibility_;

private:
	// コピーコンストラクタの隠蔽
	TranslationModel(const TranslationModel& copy);

	// 代入コピーの隠蔽
	void operator =(const TranslationModel& copy);


};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of TRANSLATION_MODEL_H_
//------------------------------------------------------------------------------

